#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "error_handling.h"

#define INIT_SIZE 10


void lock(){
    // platform specific code here
}
void unlock(){
    // platform specific code here
}


int size;
char* buffer = 0;
FILE* file = 0;

RESULT init() {
    ERROR_IF_NOT_NULL(buffer);
    INIT_STATUS;

    lock();
    STATUS = realloc_buffer(INIT_SIZE);
    HANDLE_ERROR_ON_FAIL;
    unlock();
    return OK;
	

    START_ERROR_HANDLING;
    unlock();
    END_ERROR_HANDLING;
}

RESULT finalize() {
    return free_buffer();
}

RESULT open(char* path) {
    ERROR_IF_NOT_NULL(file);
    INIT_STATUS;

    lock();
    file = fopen(path, "r");
    //ERROR_IF_NULL(file);
    HANDLE_ERROR_ON_FAIL;
    unlock();
    return OK;
	
    START_ERROR_HANDLING;
    unlock();
    END_ERROR_HANDLING;
}

RESULT read_line(char ** line) {
    ERROR_IF_NULL(file);
    ERROR_IF_NULL(buffer);
    INIT_STATUS;

    lock();

    int pos = 0;
    int c = 0;
	
    if (feof(file)) {
        *line = 0;
        unlock();
        return OK;
    }

    while (1) {
        if (pos >= size) {
            STATUS = inflate_buffer();
            HANDLE_ERROR_ON_FAIL;
        }

        int c = fgetc(file);
        if (c == EOF || c == '\n') {
            break;
        }
        buffer[pos++] = (char)c;
	}

    buffer[pos] = 0;
    *line = (char*)malloc(sizeof(char) * (pos + 1));
    strcpy(*line, buffer);

    unlock();

    return OK;	
	

    START_ERROR_HANDLING;
    unlock();
    END_ERROR_HANDLING;
}

RESULT close() {
    ERROR_IF_NULL(file);

    lock();
    fclose(file);
    file = 0;
    unlock();

    return OK;
}

RESULT realloc_buffer(int new_size) {
    buffer = realloc(buffer, new_size * sizeof(char));
    ERROR_IF_NULL(buffer);
    size = new_size;
    return OK;
}

RESULT inflate_buffer() {
    return realloc_buffer(size * 2);
}

RESULT free_buffer() {
    ERROR_IF_NULL(buffer);

    lock();

    free(buffer);
    buffer = 0;
    size = 0;

    unlock();

    return OK;
}

int find_newline(char* bfr, int from) {
    char* pos = bfr + from;

    while (*pos != 0) {
        if (*pos = '\n')
            return pos - bfr;
        pos++;
    }

    return -1;
}

